/*
 * wangjian<wangjian@minigui.org>
 */


/*the size of soft key board window*/
#define SKB_WIN_W       320
#define SKB_WIN_H       120

#define SKB_CLOSE_L     260
#define SKB_CLOSE_T     4
#define SKB_CLOSE_R     320
#define SKB_CLOSE_B     25

#define SKB_VW_L        10
#define SKB_VW_T        3
#define SKB_VW_R        260
#define SKB_VW_B        20

#define SKB_VW_PU_L     10
#define SKB_VW_PU_T     3
#define SKB_VW_PU_R     30
#define SKB_VW_PU_B     20

#define SKB_VW_PD_L     214
#define SKB_VW_PD_T     3
#define SKB_VW_PD_R     234
#define SKB_VW_PD_B     20 

#define SKB_SW_L        30
#define SKB_SW_T		18 
#define SKB_SW_R        200
#define SKB_SW_B		28 

#define SKB_KW_L        0  
#define SKB_KW_T        30 
#define SKB_KW_R        320
#define SKB_KW_B        120

/***** rectangle of the keys*****/
//For en keyboard....
#define RECT_EN_KEY_1           {  4,  33,  26,  49}
#define RECT_EN_KEY_2           { 36,  33,  58,  49}
#define RECT_EN_KEY_3           { 68,  33,  90,  49}
#define RECT_EN_KEY_4           {100,  33, 122,  49}
#define RECT_EN_KEY_5           {133,  33, 155,  49}
#define RECT_EN_KEY_6           {165,  33, 187,  49}
#define RECT_EN_KEY_7           {197,  33, 219,  49}
#define RECT_EN_KEY_8           {229,  33, 251,  49}
#define RECT_EN_KEY_9           {261,  33, 283,  49}
#define RECT_EN_KEY_10          {294,  33, 316,  49}
#define RECT_EN_KEY_11          { 19,  56,  43,  72}
#define RECT_EN_KEY_12          { 51,  56,  75,  72}
#define RECT_EN_KEY_13          { 83,  56, 107,  72}
#define RECT_EN_KEY_14          {115,  56, 139,  72}
#define RECT_EN_KEY_15          {148,  56, 172,  72}
#define RECT_EN_KEY_16          {180,  56, 204,  72}
#define RECT_EN_KEY_17          {212,  56, 236,  72}
#define RECT_EN_KEY_18          {245,  56, 269,  72}
#define RECT_EN_KEY_19          {277,  56, 301,  72}
#define RECT_EN_KEY_20          {  4,  78,  38,  94}
#define RECT_EN_KEY_21          { 51,  78,  75,  94}
#define RECT_EN_KEY_22          { 84,  78, 107,  94}
#define RECT_EN_KEY_23          {116,  78, 139,  94}
#define RECT_EN_KEY_24          {148,  78, 170,  94}
#define RECT_EN_KEY_25          {181,  78, 203,  94}
#define RECT_EN_KEY_26          {213,  78, 235,  94}
#define RECT_EN_KEY_27          {245,  78, 267,  94}
#define RECT_EN_KEY_28          {278,  78, 314,  94}
#define RECT_EN_KEY_29          {  4, 101,  38, 117}
#define RECT_EN_KEY_30          { 43, 101,  71, 117}
#define RECT_EN_KEY_31          { 78, 101, 253, 117}
#define RECT_EN_KEY_32          {262, 101, 314, 117}

//For num keyboard....
#define RECT_NUM_KEY_1           {  2,  34,  28,  50}
#define RECT_NUM_KEY_2           { 33,  34,  59,  50}
#define RECT_NUM_KEY_3           { 65,  34,  92,  50}
#define RECT_NUM_KEY_4           { 97,  34, 124,  50}
#define RECT_NUM_KEY_5           {129,  34, 156,  50}
#define RECT_NUM_KEY_6           {161,  34, 188,  50}
#define RECT_NUM_KEY_7           {193,  34, 220,  50}
#define RECT_NUM_KEY_8           {225,  34, 252,  50}
#define RECT_NUM_KEY_9           {257,  34, 284,  50}
#define RECT_NUM_KEY_10          {289,  34, 316,  50}
#define RECT_NUM_KEY_11          {  2,  56,  28,  73}
#define RECT_NUM_KEY_12          { 33,  56,  59,  73}
#define RECT_NUM_KEY_13          { 65,  56,  92,  73}
#define RECT_NUM_KEY_14          { 97,  56, 124,  73}
#define RECT_NUM_KEY_15          {129,  56, 156,  73}
#define RECT_NUM_KEY_16          {161,  56, 188,  73}
#define RECT_NUM_KEY_17          {193,  56, 220,  73}
#define RECT_NUM_KEY_18          {225,  56, 252,  73}
#define RECT_NUM_KEY_19          {257,  56, 284,  73}
#define RECT_NUM_KEY_20          {289,  56, 316,  73}
#define RECT_NUM_KEY_21          {  2,  79,  38,  96}
#define RECT_NUM_KEY_22          { 49,  79,  89,  96}
#define RECT_NUM_KEY_23          { 94,  79, 134,  96}
#define RECT_NUM_KEY_24          {139,  79, 178,  96}
#define RECT_NUM_KEY_25          {183,  79, 223,  96}
#define RECT_NUM_KEY_26          {228,  79, 268,  96}
#define RECT_NUM_KEY_27          {278,  79, 314,  96}
#define RECT_NUM_KEY_28          {  4, 101,  64, 117}
#define RECT_NUM_KEY_29          { 68, 101,  95, 117}
#define RECT_NUM_KEY_30          {100, 101, 243, 117}
#define RECT_NUM_KEY_31          {248, 101, 316, 117}


